/*
mIRC Password Keeper [/pkeeper]
send bug or comments to xtertech@gmail.com
credit goes to > mirc.hlp (original mirc help file), #batch89 & www.mircmalaysia.com
*/

; DIALOG
dialog p.keeper {
  title "Password Keeper [/pkeeper]"
  size -1 -1 162 139
  option dbu
  icon $mircexe, 20
  list 2, 3 19 155 68, size
  text "mIRC Password Keeper", 1, 5 5 70 8
  text "Password:", 3, 5 93 28 8
  text "Note:", 4, 5 105 25 8
  edit "", 5, 33 92 64 11, autohs
  edit "", 6, 33 104 125 11, autohs
  button "Add", 7, 99 91 28 12
  button "Remove", 8, 130 91 28 12
  button "OK", 9, 130 123 28 12, ok
  button "?", 10, 116 123 12 12
  box "", 11, 1 -1 160 16
  box "", 12, 1 13 160 106
  box "", 13, 1 117 160 21
}

; DIALOG EVENT
ON *:DIALOG:p.keeper:*:*:{
  if ($devent == INIT) {
    dll $mdx MarkDialog $dname
    dll $mdx SetFont 1 13 700 Tahoma
    dll $mdx SetFont 3,4,5,6,7,8,9,10 13 100 Tahoma
    dll $mdx SetBorderStyle 7,8,9,10 staticedge
    dll $mdx SetControlMDX p.keeper 2 listview rowselect showsel single headerdrag labeltip report > $views
    did -i p.keeper 2 1 headerdims 100:1 190:2 | did -i p.keeper 2 1 headertext Password $chr(9) Note
    pkeeper.load
  }
  elseif ($devent == DCLICK) && ($did(2).sel) { .clipboard $right($gettok($did(2).seltext,1,9),-11) }
  elseif ($devent == SCLICK) {
    if ($did == 10 ) { run readme.txt }
    if ($did == 7) {
      if (!$did(5) && !$did(6)) { .echo -q $input(Password and note field is empty! $crlf $+ Please fill the field to add new password.,dow,Error!))) | return } 
      .write password.txt $replace($did(p.keeper,5).text,$chr(9),$chr(32)) $+ $chr(9) $+ $replace($did(p.keeper,6).text,$chr(9),$chr(32))
      .did -a p.keeper 2 0 0 0 0 $gettok($read(password.txt,$lines(password.txt)),1,9) $+ $chr(9) $+ $gettok($read(password.txt,$lines(password.txt)),2,9)
    }
    if ($did == 8) {
      if (!$did($dname,2).sel) { .echo -q $input(No password selected! $crlf $+ Please select one to remove.,dow,Error!))) | return }
      .write -dl $+ $calc($did(2).sel - 1) password.txt | did -d p.keeper 2 $did(2).sel
    }
  }
}

; ALIASES
alias mdx return mdx.dll
alias views return views.mdx
alias pkeeper {
  if ($dialog(p.keeper) == $null) { dialog -m p.keeper p.keeper }
  dialog -v p.keeper
}
alias -l pkeeper.load {
  did -r p.keeper 2 
  var %pass.tmp = 1
  while ($read(password.txt,%pass.tmp)) {
    var %pass.tmp.sel = $read(password.txt,%pass.tmp)
    var %pass.tmp.sel2 = $gettok(%pass.tmp.sel,1,245) 
    var %pass.tmp.sel3 = $gettok(%pass.tmp.sel,2,245)
    did -a p.keeper 2 0 0 0 0 $+(%pass.tmp.sel2,	,%pass.tmp.sel3) 
    inc %pass.tmp
  }
}

; EVENT
ON *:LOAD: {
  .echo -s /*
  .echo -s mIRC Password Keeper [/pkeeper]
  .echo -s succesfuly loaded $script
  .echo -s send bug or comments to xtertech@gmail.com
  .echo -s credit goes to > mirc.hlp (original mirc help file), #batch89 & www.mircmalaysia.com
  .echo -s */
}

; POPUPS MENU
menu status,menubar,channel {
  Password Keeper:pkeeper
}
